var debug = require("util").debuglog("nyu")
var fs = require("fs")
var Bookshelf = require("bookshelf")

module.exports = function ($nyu, $knex) {
	var bookshelf = Bookshelf($knex)
	bookshelf.plugin("registry")
	bookshelf.plugin("virtuals")

	$nyu.invoke(function ($koa) {
		Object.defineProperty($koa.context, "database", {
			enumerable: true,
			value: bookshelf
		})
	})

	// load all models
	var models = []
	fs.readdirSync($nyu.resolve("app/models")).forEach(function (file) {
		debug("loading model %s", file)
		var model = $nyu.require("app/models", file)
		var name = model.name

		var methods = model.methods || {}
		methods.tableName = name.toLowerCase()
		methods.virtuals = model.virtuals || {}
		methods.defaults = model.defaults || {}

		if (model.constructor) {
			var ctor = model.constructor
			methods.constructor = function () {
				bookshelf.Model.apply(this, arguments)
				ctor.apply(this, arguments)
			}
		}

		model = bookshelf.Model.extend(methods, model.statics || {})

		bookshelf.model(name, model)
		debug("model %s registered as %s", file, name)
	})

	return bookshelf
}
