var etc = require("etc")("::")
etc.use(require("etc-yaml"))

module.exports = function ($package) {
	return etc
		.argv()
		.env($package.name)
		.folder("config")
		.add({
			database: {
				redis: {
					host: "127.0.0.1",
					port:  6379,
					db: 0,
					password: null
				},

				thinky: {
					database: "nyu",
					password: "",
					host: "127.0.0.1",
					port: null,
				}
			},

			http: {
				static: {
					disable: false,
					maxAge: 0,
					index: "index.html"
				}
			},

			security: {
				cookie: {
					httpOnly: true,
					path: '/',
					overwrite: true,
					signed: true,
					maxAge: 24 * 60 * 60 * 1000
				},
				keys: [ "not so seekret" ]
			},

			session: {
				store: {
					type: "memory"
				},
				ttl: null
			},

			views: {
				locals: {},
				errorView: "error"
			}
		})
}
