var debug = require("util").debuglog("nyu")
var Knex = require("knex")

module.exports = function ($nyu, $config) {
	try {
		var config = $config.get("database::bookshelf")
		var knex = Knex({
			client: config.adapter,
			connection: {
				host: config.host,
				port: config.port,
				user: config.username,
				password: config.password,
				database: config.database,
				filename: config.storage
			},
			migrations: {
				directory: $nyu.resolve("app/migrations")
			}
		})

		return knex
	} catch (ex) {
		debug("failed to create knex client", ex)
		return null
	}
}
