var passport = require("koa-passport")
var debug = require("util").debuglog("NYU")
var Acl = require("acl")

function create(constuctor, args) {
	var i = Object.create(constructor)
	var r = contructor.apply(i, args)
	return Object(r) === r? r: i;
}

module.exports = function ($nyu, $config, $redis) {
	try {
		var backend = new Acl.memoryBackend()
		if ($redis) {
			backend = new Acl.redisBackend($redis, "acl")
		}
		var acl = new Acl(backend)

		$nyu.invoke(function ($koa) {
			Object.defineProperty($koa.context, "acl", {
				enumerable: true,
				value: acl
			})
			Object.defineProperty($koa.context, "authenticate", {
				enumerable: true,
				get: function () {
					return passport.authenticate.bind(passport)
				}
			})
		})

		$nyu.invoke("app/initializers/security", { passport: passport, acl: acl })

		var stack = [
			passport.initialize(),
			passport.session()
		].reverse()

		return function* (next) {
			stack.forEach(function (mw) {
				next = mw.call(this, next)
			}, this)

			yield* next
		}
	} catch (ex) {
		debug("failed to create security middleware stack", ex)
		return function* (next) {
			yield next
		}
	}
}
