var npmlog = require("npmlog")

function Logger(prefix) {
	this.prefix = prefix
}

Logger.prototype.log = function (lvl, message) {
	npmlog.log(lvl, this.prefix, message)
}

Object.keys(npmlog.levels).forEach(function (level) {
	Logger.prototype[level] = function (message) {
		this.log(level, message)
	}
})

npmlog.getLogger = function (prefix) {
	return new Logger(prefix)
}

var addLevel = npmlog.addLevel.bind(npmlog)
npmlog.addLevel = function (level) {
	Logger.prototype[level] = function (message) {
		this.log(level, message)
	}

	addLevel.apply(npmlog, arguments)
}

npmlog.level = "silly"

module.exports = npmlog
