var util = require("nyutil")
var debug = util.debuglog("nyu:thinky")
var fs = require("fs")
var Thinky = require("thinky")
var EventEmitter = require("events")

module.exports = function ($nyu, $config) {
	var config = $config.get("database::thinky")
	var thinky = Thinky({
		host: config.host,
		port: config.port,
		authKey: config.password,
		db: config.database
	})

	$nyu.invoke(function ($koa) {
		Object.defineProperty($koa.context, "database", {
			enumerable: true,
			value: thinky
		})
	})

	console.log(util)
	util.object.mixin(thinky, EventEmitter)

	// load all models
	var models = []
	fs.readdirSync($nyu.resolve("app/models")).forEach(function (file) {
		var model = $nyu.require("app/models", file)
		if (!model.define) {
			return
		}

		debug("registering model %s", file)
		model.define(thinky)
	})

	return thinky
}
