var util = require("util")
var debug = util.debuglog("nyu")

function merge(target, object) {
	var objects = Array.prototype.slice.call(arguments, 1)

	objects.forEach(function (obj) {
		if (!util.isObject(obj)) {
			return
		}

		Object.keys(obj).forEach(function (key) {
			target[key] = obj[key]
		})
	})

	return target
}

var patches = [
	function (koa) {
		var _renderer
		Object.defineProperty(koa.context, "render", {
			get: function () {
				return function () {
					debug("mixing in application locals")
					var args = Array.prototype.slice.call(arguments)

					args[1] = merge(
						{},
						this.app.locals,
						this.locals,
						args[1],
						// super globals
						{
							ctx: this
						}
					)

					debug("calling native renderer")
					return _renderer.apply(this, args)
				}
			},
			set: function (renderer) {
				debug("new render engine set")
				_renderer = renderer
			}
		})
	}
]

module.exports = function (koa) {
	patches.forEach(function (patch) {
		patch(koa)
	})
}
